<?php
/**
 * Ahthor: lf
 * Email: job@feehi.com
 * Blog: http://blog.feehi.com
 * Date: 2016/4/711:37
 */
namespace backend\models;

use yii;

class FriendLink extends \common\models\FriendLink
{

    public function rules()
    {
        return [
            [['target'], 'string'],
            [['sort', 'status', 'created_at', 'updated_at'], 'integer'],
            [['name', 'image', 'url'], 'string', 'max' => 255],
            [['name', 'url'], 'required'],
        ];
    }

    public function beforeSave($insert)
    {
        if($insert){
            $this->created_at = time();
        }else{
            $this->updated_at = time();
        }
        if(isset($_FILES['FriendLink']['name']['image']) && $_FILES['FriendLink']['name']['image'] != ''){
            if(!$insert) {
                if(!empty($this->oldAttributes['image'])) {
                    $fileUsageModel = new FileUsage();
                    $fileUsageModel->cancelUseFile($this->oldAttributes['image'], $this->id, FileUsage::TYPE_FRINEDLYLINK);
                }
            }
            $model = new File();
            if (($uri = $model->saveFile(FileUsage::TYPE_FRINEDLYLINK)) !== false) {
                $this->image = $uri;
                return true;
            } else {
                $this->addError('thumb', yii::t('app', 'Upload {attribute} error'), ['attribute' => yii::t('app', 'Image')]);
                return false;
            }
        }
        if($this->image == '') unset($this->image);
        return parent::beforeSave($insert); // TODO: Change the autogenerated stub
    }

    public function afterSave($insert, $changedAttributes)
    {
        if( isset($this->image) ){
            $fileUsageModel = new FileUsage();
            $fileUsageModel->useFile($this->image, $this->id, FileUsage::TYPE_FRINEDLYLINK);
        }
        return true;
    }

    public function beforeDelete()
    {
        if( !empty($this->image) ) {
            $fileUsageModel = new FileUsage();
            $fileUsageModel->cancelUseFile($this->image, $this->id, FileUsage::TYPE_FRINEDLYLINK);
        }
        return true;
    }
}